try {
importScripts("../pjcl.js");
} catch(e) {throw new Error("could not import ../pjcl.js");}
try {
importScripts("AddStackToError.js");
} catch(e) {throw new Error("could not import AddStackToError.js");}

onmessage = function(e) { try {
	var p = pjclHex2BigInt(e.data[0]);
	var q = pjclHex2BigInt(e.data[1]);
	var g = pjclHex2BigInt(e.data[2]);
	var x = pjclHex2BigInt(e.data[3]);
	var y = pjclHex2BigInt(e.data[4]);
	var validatePubKey = e.data[5];
	var count = e.data[6];
	var repetitions = e.data[7];
	var minTotalTime = Number.POSITIVE_INFINITY;
	if (validatePubKey) {
		var valid = pjclFFCValidatePublicKey(p,q,g,y);
		postMessage([0,valid]);
	}
	for (var j = 1; j <= repetitions; j++) {
		if (validatePubKey) {
			var t1 = performance.now();
			for (var i = 0; i < count; i++) {
				var valid = pjclFFCValidatePublicKey(p,q,g,y);
				var sharedSecret = pjclDH(p,x,y);
			}
			var t2 = performance.now();
		}
		else {
			var t1 = performance.now();
			for (var i = 0; i < count; i++) {
				var sharedSecret = pjclDH(p,x,y);
			}
			var t2 = performance.now();
		}
		var totalTime = t2 - t1;
		if (totalTime < minTotalTime) {
			minTotalTime = totalTime;
		}
		if (j < repetitions) {
			postMessage([j,totalTime]);
		}
		else {
			var sharedSecret_hex = pjclByteArray2Hex(sharedSecret);
			postMessage([j,totalTime,sharedSecret_hex,minTotalTime]);
		}
	}
	close();
} catch(e) {
	throw new Error(pjclAddStackToError(e));
}}
